///+-----------------------------------------------------------------+
//|                                                      RSI_SMA.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 2
#property indicator_level1 15
#property indicator_level2 85
#property  indicator_color1 Magenta
#property  indicator_color2 Silver
//---- indicator parameters
extern int RSIPeriod=5;
extern int SMATrigger=5;
//---- indicator buffers
double     ind_buffer1[];
double     ind_buffer2[];
double     ind_buffer3[];
double     ind_buffer4[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 2 additional buffers are used for counting.
   IndicatorBuffers(4);
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexDrawBegin(0,RSIPeriod);
   SetIndexStyle(0,DRAW_LINE,STYLE_DOT,1);
   SetIndexDrawBegin(0,SMATrigger);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+2);
//---- 3 indicator buffers mapping
   if(!SetIndexBuffer(0,ind_buffer1) &&
      !SetIndexBuffer(1,ind_buffer2) &&
      !SetIndexBuffer(2,ind_buffer3) &&
      !SetIndexBuffer(3,ind_buffer4))
      Print("cannot set indicator buffers!");
//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("RSI_SMA("+RSIPeriod+","+SMATrigger+")");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//|RSI of Simple Moving Average                                      |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars=IndicatorCounted();
//---- check for possible errors
   if(counted_bars<0) return(-1);
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
//---- rsi counted in the 1-st additional buffer
   for(int i=0; i<limit; i++)
      ind_buffer1[i]=iMA(NULL,0,5,0,MODE_SMA,PRICE_CLOSE,i);
//---- signal line counted in the 2-nd additional buffer
   for(i=0; i<limit; i++)
      ind_buffer2[i]=iRSIOnArray(ind_buffer1,Bars,RSIPeriod,i);
//+------------------------------------------------------------------+
//|Simple Moving Average of RSI (Trigger)                            |
//+------------------------------------------------------------------+
//---- rsi counted in the 1-st additional buffer
   for(i=0; i<limit; i++)
      ind_buffer3[i]=iRSI(NULL,0,5,PRICE_CLOSE,i);
//---- signal line counted in the 2-nd additional buffer
   for(i=0; i<limit; i++)
      ind_buffer4[i]=iMAOnArray(ind_buffer3,Bars,SMATrigger,0,MODE_SMA,i);
   return(0);
  }
//+---------------------------------------------------------------------------------------------+